//
//  Item.swift
//  SwiftDataGrades
//
//  Created by Joe Gregg on 10/18/24.
//

import Foundation
import SwiftData

@Model
final class Student {
    @Attribute(.unique) var id: String = UUID().uuidString
    var first_name: String
    var last_name: String
    var grades: [Grade]
    
    init(id: String = UUID().uuidString, firstname: String, lastname: String) {
        self.id = id
        self.first_name = firstname
        self.last_name = lastname
        self.grades = []
    }
}

@Model
final class Quiz {
    @Attribute(.unique) var id: String = UUID().uuidString
    var name: String
    var points: Int
    var grades: [Grade]
    init(id: String = UUID().uuidString, name: String, points: Int) {
        self.id = id
        self.name = name
        self.points = points
        self.grades = []
    }
}

@Model
final class Grade {
    @Attribute(.unique) var id: String = UUID().uuidString
    var score : Int
    var student: Student?
    var quiz: Quiz?
    
    init(id: String = UUID().uuidString,score: Int) {
        self.id = id
        self.score = score
    }
}
