//
//  GradeDetailView.swift
//  SwiftDataGrades
//
//  Created by Joe Gregg on 10/18/24.
//

import Foundation
import SwiftData
import SwiftUI

import SwiftUI

struct GradeDetailView: View {
    @Environment(\.modelContext) private var modelContext
    let student : Student
    let quiz : Quiz
    @State var score : String = ""
    @Query var grades: [Grade]
    
    init(student: Student,quiz: Quiz) {
        self.student = student
        self.quiz = quiz
        let sId = student.id
        let qId = quiz.id
        _grades = Query(filter: #Predicate { grade in
            (grade.student?.id == sId) && (grade.quiz?.id == qId)
        })
    }
    
    var body: some View {
        VStack {
            if grades.isEmpty {
                HStack {
                    Text("Score:")
                    TextField("",text:$score)
                }
                Button("Save") {
                    let g = Grade(score: Int(score) ?? 0)
                    g.quiz = quiz
                    g.student = student
                    quiz.grades.append(g)
                    student.grades.append(g)
                    try? modelContext.save()
                }
            } else {
                Text("Existing score is \(grades[0].score)")
                HStack {
                    Text("Update score:")
                    TextField("",text:$score)
                }
                Button("Save") {
                    grades[0].score = Int(score) ?? 0
                    try? modelContext.save()
                }
            }
        }
    }
    
}

