//
//  QuizView.swift
//  SwiftDataGrades
//
//  Created by Joe Gregg on 10/18/24.
//

import Foundation
import SwiftData
import SwiftUI

struct QuizView: View {
    @Environment(\.modelContext) private var modelContext
    @Query private var quizzes: [Quiz]
    @State var name : String = ""
    @State var max_points : String = ""
    var body: some View {
        VStack {
            List {
                ForEach(quizzes) { quiz in
                    Text(quiz.name)
                }.onDelete(perform: delete)
            }
            HStack {
                Text("Name:")
                TextField("",text:$name).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            HStack {
                Text("Points:")
                TextField("",text:$max_points).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            Button("Add Quiz") {
                let quiz = Quiz(name:name,points:Int(max_points) ?? 100)
                modelContext.insert(quiz)
                try? modelContext.save()
            }
        }
    }
    
    func delete(at offsets: IndexSet) {
        offsets.forEach { i in
            modelContext.delete(quizzes[i])
        }
        try? modelContext.save()
    }
}
