//
//  StudentView.swift
//  SwiftDataGrades
//
//  Created by Joe Gregg on 10/18/24.
//

import Foundation
import SwiftData
import SwiftUI

struct StudentView: View {
    @Environment(\.modelContext) private var modelContext
    @Query private var students: [Student]
    @State var first_name : String = ""
    @State var last_name : String = ""
    var body: some View {
        VStack {
            List {
                ForEach(students) { student in
                    Text("\(student.first_name) \(student.last_name)")
                }.onDelete(perform: delete)
            }
            HStack {
                Text("First Name:")
                TextField("",text:$first_name).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            HStack {
                Text("Last Name:")
                TextField("",text:$last_name).disableAutocorrection(true).textFieldStyle(.roundedBorder)
            }
            Button("Add Student") {
                let student = Student(firstname: first_name, lastname: last_name)
                modelContext.insert(student)
                try? modelContext.save()
            }
        }
    }
    
    func delete(at offsets: IndexSet) {
        offsets.forEach { i in
            modelContext.delete(students[i])
        }
        try? modelContext.save()
    }
}
