//
//  SwiftDataGradesApp.swift
//  SwiftDataGrades
//
//  Created by Joe Gregg on 10/18/24.
//

import SwiftUI
import SwiftData

@main
struct SwiftDataGradesApp: App {
    var sharedModelContainer: ModelContainer = {
        let schema = Schema([
            Student.self,Quiz.self,Grade.self
        ])
        let modelConfiguration = ModelConfiguration(schema: schema, isStoredInMemoryOnly: false)

        do {
            return try ModelContainer(for: schema, configurations: [modelConfiguration])
        } catch {
            fatalError("Could not create ModelContainer: \(error)")
        }
    }()

    var body: some Scene {
        WindowGroup {
            ContentView()
        }
        .modelContainer(sharedModelContainer)
    }
}
